## phcpack 2.4.90+dfsg

=== src/Python/PHCpy2/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/phcpy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/phcpy.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/phcpy"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/phcpy"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

## phcpack 2.4.85+dfsg

=== debian/changelog ===
phcpack (2.4.85+dfsg-5build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 19:35:10 +0000

phcpack (2.4.85+dfsg-5) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/control
    - Use secure URI in Homepage field.
  * debian/copyright
    - Use spaces rather than tabs to start continuation lines.
  * debian/upstream/metadata
    - Set upstream metadata fields: Bug-Submit, Repository,
      Repository-Browse.

  [ Doug Torrance ]
  * debian/control
    - Add support for "nopython" and "nodoc" build profiles.
  * debian/copyright
    - Update my copyright years.
  * debian/rules
    - Don't build PHCpy when "nopython" is in DEB_BUILD_PROFILES.
  * debian/tests/phcpy-test.py
    - Adjust random seed again; the seed introduced in 2.4.85+dfsg-3
      resulted in solve_rps10() failing on armhf.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 17 Feb 2022 21:26:14 -0500

phcpack (2.4.85+dfsg-4) unstable; urgency=medium

  * debian/rules
    - Use /bin/sh for calling "command" shell builtin; should fix builds in
      kFreeBSD and Hurd.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 01 Jan 2022 15:24:53 -0500

phcpack (2.4.85+dfsg-3) unstable; urgency=medium

  * debian/control
    - Split build dependencies needed only for architecture dependent
      (resp., independent) packages to Build-Depends-Arch (resp.,
      Build-Depends-Indep).
    - Add dh-sequence-* build dependencies for python3 and sphinxdoc.
    - Set Multi-Arch to "foreign" for phcpack-doc.
  * debian/rules
    - Several updates to facilitate the Build-Depends-Arch/Indep split:
      + Customize dh options based on whether dh_octave/pybuild are
        present.
      + Only set build flags when gnatgcc is present.
      + Don't let dh_auto_clean fail when dh_octave isn't present.
  * debian/tests/phcpy-test.py
    - Tweak random seed; otherwise solve_rps10() fails on i386, presumably
      due to 80-bit floating point precision.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 01 Jan 2022 00:16:57 -0500

phcpack (2.4.85+dfsg-2) unstable; urgency=medium

  * Source-only upload for transition to testing.
  * debian/*
    - Update my email address; now a Debian Developer.
  * debian/control
    - Update Maintainer to Debian Math Team.
    - Bump Standards-Version to 4.6.0.
    - Update Vcs-* URL's (science-team -> math-team).
  * debian/patches/avoid-gcc-bug.patch
    - New patch; void internal compiler errors with GCC 11.
  * debian/patches/escape-backslash.patch
    - Escape backslash in documentation config.  Otherwise we get a
      "'unicodeescape' codec can't decode bytes" error with newer versions
      of Python.
  * debian/rules
    - Drop back to C++14 to prevent FTBFS.
  * debian/source/lintian-overrides
    - Update source-is-missing override; line length info is no longer
      included.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 29 Dec 2021 13:17:31 -0500

phcpack (2.4.85+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #820848).

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 11 Jul 2021 15:08:03 +0530

=== debian/control ===
Source: phcpack
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-sphinxdoc <!nodoc>,
               dvipng <!nodoc>,
               python3-sphinx ,
               texlive-latex-base <!nodoc>,
               texlive-latex-extra <!nodoc>
Build-Depends-Arch: dh-python <!nopython>,
                    dh-sequence-python3 <!nopython>,
                    gnat,
                    gprbuild,
                    jdupes <!nopython !nodoc>,
                    python3-all-dev <!nopython>,
                    python3-tk <!nopython>
Build-Depends-Indep: dh-octave
Standards-Version: 4.6.0
Homepage: https://homepages.math.uic.edu/~jan/PHCpack/phcpack.html
Vcs-Browser: https://salsa.debian.org/math-team/phcpack
Vcs-Git: https://salsa.debian.org/math-team/phcpack.git
Rules-Requires-Root: no

Package: phcpack
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: phcpack-doc (= ${source:Version})
Suggests: macaulay2, octave-phclab (= ${source:Version})
Description: general-purpose solver for polynomial systems (command line)
 PHCpack is a software package to solve polynomial systems by homotopy
 continuation methods.
 .
 A polynomial system is given as a sequence of polynomials in several
 variables.  Homotopy continuation methods operate in two stages. In
 the first stage, a family of polynomial systems (the so-called
 homotopy) is constructed. This homotopy contains a polynomial system
 with known solutions. In the second stage, numerical continuation
 methods are applied to track the solution paths defined by the
 homotopy, starting at the known solutions and leading to the solutions
 of the given polynomial system.
 .
 This package contains the command line interface to PHCpack.

Package: phcpack-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Build-Profiles: <!nodoc>
Description: general-purpose solver for polynomial systems (documentation)
 PHCpack is a software package to solve polynomial systems by homotopy
 continuation methods.
 .
 A polynomial system is given as a sequence of polynomials in several
 variables.  Homotopy continuation methods operate in two stages. In
 the first stage, a family of polynomial systems (the so-called
 homotopy) is constructed. This homotopy contains a polynomial system
 with known solutions. In the second stage, numerical continuation
 methods are applied to track the solution paths defined by the
 homotopy, starting at the known solutions and leading to the solutions
 of the given polynomial system.
 .
 This package contains demo files and documentation.

Package: python3-phcpy
Section: python
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Build-Profiles: <!nopython>
Description: general-purpose solver for polynomial systems (Python)
 PHCpack is a software package to solve polynomial systems by homotopy
 continuation methods.
 .
 A polynomial system is given as a sequence of polynomials in several
 variables.  Homotopy continuation methods operate in two stages. In
 the first stage, a family of polynomial systems (the so-called
 homotopy) is constructed. This homotopy contains a polynomial system
 with known solutions. In the second stage, numerical continuation
 methods are applied to track the solution paths defined by the
 homotopy, starting at the known solutions and leading to the solutions
 of the given polynomial system.
 .
 This package contains PHCpy, the Python interface to PHCpack.

Package: octave-phclab
Architecture: all
Depends: phcpack (>= ${source:Version}), ${misc:Depends}, ${octave:Depends}
Description: general-purpose solver for polynomial systems (Octave)
 ${octave:Upstream-Description}

=== debian/rules ===
#!/usr/bin/make -f

command = $(shell /bin/sh -c "command -v $(1)")

ifneq (,$(call command, dh_octave_version))
DH_OPTIONS = --with octave
endif

ifneq (,$(call command, pybuild))
DH_OPTIONS += --buildsystem=pybuild
PYTHON3 := $(shell pybuild --system distutils --print {interpreter.include_dir})
endif

%:
	dh $@ $(DH_OPTIONS)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

# drop back to C++14 (https://github.com/janverschelde/PHCpack/issues/55)
export DEB_CXXFLAGS_MAINT_APPEND = -std=gnu++14

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
GPRBUILD_OPTS = -v
else
GPRBUILD_OPTS =
endif

GPRBUILD_OPTS += -R # prevent custom-library-search-path lintian error

ifneq (,$(call command, gnatgcc))
gnat_version := $(shell gnatgcc -dumpversion)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk
endif

export PYBUILD_DIR = src/Python/PHCpy3

override_dh_auto_build-arch:
	@echo "+------------------+"
	@echo "| building PHCpack |"
	@echo "+------------------+"
	cd src/Ada/Main && gprbuild $(GPRBUILD_OPTS) main.gpr
	cp src/bin/phctop src/bin/phc
	$(MAKE) -C src/doc man
ifeq (,$(filter nopython, $(DEB_BUILD_PROFILES)))
	@echo "+----------------+"
	@echo "| building PHCpy |"
	@echo "+----------------+"
	cd src/Ada/Main && gprclean main.gpr # so we can recompile with -fPIC
	$(MAKE) -C src/Objects phcpy2c3.so \
		PYTHON3=$(PYTHON3)         \
		GNATFLAGS="$(ADAFLAGS)"
	pybuild --build
ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
	@echo "+---------------------+"
	@echo "| building PHCpy docs |"
	@echo "+---------------------+"
	$(MAKE) -C src/Python/PHCpy3/doc html
	jdupes -l src/Python/PHCpy3/doc/build/html/_images/math
endif
endif

ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
override_dh_auto_build-indep:
	@echo "+-----------------------+"
	@echo "| building PHCpack docs |"
	@echo "+-----------------------+"
	$(MAKE) -C src/doc html
endif

# skip upstream test suite for now
# https://github.com/janverschelde/PHCpack/issues/41
# override_dh_auto_test:
#	$(MAKE) -C src/Objects testall

M_FILES := $(patsubst src/Octave/%.m,inst/%.m,$(wildcard src/Octave/*.m))

execute_before_dh_octave_version: DESCRIPTION

execute_after_dh_auto_install-indep: phclab-banner COPYING DESCRIPTION \
	inst/PKG_ADD $(M_FILES)
	dh_auto_install --buildsystem=octave
# dh_octave installs everything in debian/phcpack, since that's the name of the
# source package, but we want the files under debian/tmp where dh_install can
# find them
	mkdir -p debian/tmp/usr/share
	mv debian/phcpack/usr/share/octave debian/tmp/usr/share
	rm -rf debian/phcpack

phclab-banner:
	@echo "+-----------------+"
	@echo "| building PHClab |"
	@echo "+-----------------+"

COPYING: src/Octave/COPYING.txt
	cp $< $@

include /usr/share/dpkg/pkg-info.mk
DESCRIPTION: debian/DESCRIPTION.in
	sed -e "s/@VERSION@/$(DEB_VERSION_UPSTREAM)/" \
	    -e "s/@DATE@/$(shell date -u -I -d@$(SOURCE_DATE_EPOCH))/" $< > $@

inst/PKG_ADD: inst
	echo 'set_phcpath("/usr/bin/phc")' > $@

inst/%.m: src/Octave/%.m inst
	cp $< $@

inst:
	mkdir -p $@

override_dh_octave_substvar:
	dh_octave_substvar -poctave-phclab

override_dh_clean:
	dh_clean -Xbak

execute_after_dh_auto_clean-arch:
	$(MAKE) -C src/Objects clean
	$(MAKE) -C src/Python/PHCpy3/doc clean

execute_after_dh_auto_clean-indep:
	$(MAKE) -C src/doc clean
	dh_auto_clean --buildsystem=octave || true
	rm -rf inst

.PHONY: phclab-banner

=== debian/tests/control ===
Tests: phcpy-test.py
Depends: python3-phcpy

Tests: phclab-test.m
Depends: octave-phclab, phcpack-doc

=== debian/watch ===
version=4
opts=dversionmangle=s/@DEB_EXT@//,repacksuffix=+dfsg \
https://github.com/janverschelde/PHCpack/releases .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## phcpack 2.4.86+dfsg

=== debian/changelog ===
phcpack (2.4.86+dfsg-4) unstable; urgency=medium

  * debian/control
    - Add Testsuite field for autopkgtest-pkg-pybuild.  This way, we'll at
      least have a superficial test to make sure that the Python module
      imports correctly even though the comprehensive test is marked as
      flaky.
  * debian/tests/control
    - Mark PHCpy test as flaky.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 03 Jan 2023 13:50:20 -0500

phcpack (2.4.86+dfsg-3) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Trivial changes for dh-ada-library/8.2

  [ Doug Torrance ]
  * debian/control
    - Bump Standards-Version to 4.6.2.
  * debian/rules
    - Skip dh_dwz to avoid build failure (Closes: #1027120).

 -- Doug Torrance <dtorrance@debian.org>  Tue, 27 Dec 2022 21:26:50 -0500

phcpack (2.4.86+dfsg-2) unstable; urgency=medium

  * debian/control
    - Add dh-sequence-octave in Build-Depends-Indep to simplify d/rules.
    - Add minimum version for dh-octave in Build-Depends-Indep.
  * debian/rules
    - Drop "--with octave"; no longer needed now that dh-sequence-octave is
      a build dependency.
    - Stop moving octave files from d/phcpack to d/tmp since dh_octave now
      installs them there in the first place (Closes: #1013619).
    - Split most of override_dh_clean recipe into
      execute_after_dh_auto_clean; they were previously in
      execute_after_dh_auto_clean-arch/indep and should be run before
      dh_clean.  Otherwise, we end up with *.debhelper.log files after the
      build, causing lintian errors.
  * debian/salsa-ci.yml
    - Ignore -fstack-protector-strong flag when running blhc as part of
      Salsa continuous integration.
  * debian/source/lintian-overrides
    - Add brackets around filename to match current Lintian output.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 25 Jun 2022 22:01:29 -0400

phcpack (2.4.86+dfsg-1) unstable; urgency=medium

  * New upstream release.

  [ Nicolas Boulenguez ]
  * debian/rules
    - disable stackprotectorstrong via hardening flags settings

  [ Doug Torrance ]
  * debian/patches
    - Remove patches applied upstream.
      + avoid-gcc-bug.patch
      + escape-backslash.patch
      + import-polynomials.patch
      + manpage.patch
      + no-intersphinx.patch
    - Refresh remaining patches for new upstream release.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 31 May 2022 09:08:01 -0400

phcpack (2.4.85+dfsg-6) unstable; urgency=medium

  [ Doug Torrance ]
  * debian/control
    - Bump Standards-Version to 4.6.1.
  * debian/copyright
    - Convert leading tabs to spaces in Files-Excluded.
  * debian/gbp.conf
    - Update debian-branch to debian/latest; recommended by DEP-14.
  * debian/rules
    - Also include /usr/share/dpkg/buildopts.mk; required by
      debian_packaging-11.mk (Closes: #1011364).
    - Remove -fstack-protector-strong from ADAFLAGS; fixes build with
      gnat-11.
  * debian/tests/control
    - Add allow-stderr restriction for PHClab test; workaround for an
      Octave bug.

  [ Nicolas Boulenguez ]
  * debian/control
    - remove dh-python dependency, dh-sequence-python3 is an alias
  * debian/rules
    - improve creation and removal of inst subdirectory
    - merge recipes for phclab
    - use unversioned ada/debian_packaging.mk from gnat (>= 11)
    - clean both -arch and -indep objects
    - search nodoc in DEB_BUILD_PROFILES, not _OPTIONS

 -- Doug Torrance <dtorrance@debian.org>  Wed, 25 May 2022 06:00:43 -0400

=== debian/control ===
--- 
+++ 
@@ -9,19 +9,20 @@
                python3-sphinx ,
                texlive-latex-base <!nodoc>,
                texlive-latex-extra <!nodoc>
-Build-Depends-Arch: dh-python <!nopython>,
-                    dh-sequence-python3 <!nopython>,
-                    gnat,
+Build-Depends-Arch: dh-sequence-python3 <!nopython>,
+                    dh-ada-library (>= 8.2),
+                    gnat (>= 11~),
                     gprbuild,
                     jdupes <!nopython !nodoc>,
                     python3-all-dev <!nopython>,
                     python3-tk <!nopython>
-Build-Depends-Indep: dh-octave
-Standards-Version: 4.6.0
+Build-Depends-Indep: dh-octave (>= 1.2.0~), dh-sequence-octave
+Standards-Version: 4.6.2
 Homepage: https://homepages.math.uic.edu/~jan/PHCpack/phcpack.html
 Vcs-Browser: https://salsa.debian.org/math-team/phcpack
 Vcs-Git: https://salsa.debian.org/math-team/phcpack.git
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: phcpack
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

command = $(shell /bin/sh -c "command -v $(1)")

ifneq (,$(call command, pybuild))
DH_OPTIONS += --buildsystem=pybuild
PYTHON3 := $(shell pybuild --system distutils --print {interpreter.include_dir})
endif

%:
	dh $@ $(DH_OPTIONS)

# With gcc-11 -fstack-protector-strong:
# gnatbind -n -static use_c2phc -o use_c2phc_binder.adb
# raised STORAGE_ERROR : stack overflow or erroneous memory access
DEB_BUILD_MAINT_OPTIONS = hardening=+all,-stackprotectorstrong optimize=-lto

# drop back to C++14 (https://github.com/janverschelde/PHCpack/issues/55)
DEB_CXXFLAGS_MAINT_APPEND = -std=gnu++14

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# This line has no effect during architecture-independent builds:
include $(wildcard /usr/share/ada/packaging.mk)

export PYBUILD_DIR = src/Python/PHCpy3

override_dh_auto_build-arch:
	@echo "+------------------+"
	@echo "| building PHCpack |"
	@echo "+------------------+"
	gprbuild $(GPRBUILDFLAGS) src/Ada/Main/main.gpr -o phc
	$(MAKE) -C src/doc man
ifeq (,$(filter nopython, $(DEB_BUILD_PROFILES)))
	@echo "+----------------+"
	@echo "| building PHCpy |"
	@echo "+----------------+"
	cd src/Ada/Main && gprclean main.gpr # so we can recompile with -fPIC
	$(MAKE) -C src/Objects phcpy2c3.so \
		PYTHON3=$(PYTHON3)         \
		GNATFLAGS="$(ADAFLAGS)"
	pybuild --build
ifeq (,$(filter nodoc, $(DEB_BUILD_PROFILES)))
	@echo "+---------------------+"
	@echo "| building PHCpy docs |"
	@echo "+---------------------+"
	$(MAKE) -C src/Python/PHCpy3/doc html
	jdupes -l src/Python/PHCpy3/doc/build/html/_images/math
endif
endif

ifeq (,$(filter nodoc, $(DEB_BUILD_PROFILES)))
override_dh_auto_build-indep:
	@echo "+-----------------------+"
	@echo "| building PHCpack docs |"
	@echo "+-----------------------+"
	$(MAKE) -C src/doc html
endif

# skip upstream test suite for now
# https://github.com/janverschelde/PHCpack/issues/41
# override_dh_auto_test:
#	$(MAKE) -C src/Objects testall

execute_before_dh_octave_version: DESCRIPTION

execute_after_dh_auto_install-indep: DESCRIPTION
	@echo "+-----------------+"
	@echo "| building PHClab |"
	@echo "+-----------------+"

	cp --update --reflink=auto src/Octave/COPYING.txt COPYING

	mkdir --parents inst
	cp --update --reflink=auto src/Octave/*.m debian/PKG_ADD inst

	dh_auto_install --buildsystem=octave

include /usr/share/dpkg/pkg-info.mk
DESCRIPTION: debian/DESCRIPTION.in
	sed -e "s/@VERSION@/$(DEB_VERSION_UPSTREAM)/" \
	    -e "s/@DATE@/$(shell date -u -I -d@$(SOURCE_DATE_EPOCH))/" $< > $@

override_dh_dwz:
# avoid the following:
# dwz: ./dwz.c:12035: adjust_exprloc: Assertion `refd != NULL &&
#   !refd->die_remove' failed.

override_dh_octave_substvar:
	dh_octave_substvar -poctave-phclab

override_dh_clean:
	dh_clean -Xbak

execute_after_dh_auto_clean:
	$(MAKE) -C src/Objects clean
	$(MAKE) -C src/Python/PHCpy3/doc clean
	$(MAKE) -C src/doc clean
	dh_auto_clean --buildsystem=octave || true

=== debian/tests/control ===
Tests: phcpy-test.py
Depends: python3-phcpy
Restrictions: flaky

Tests: phclab-test.m
Depends: octave-phclab, phcpack-doc
Restrictions: allow-stderr

## phcpack 2.4.90%2Bdfsg

=== debian/changelog ===
phcpack (2.4.90+dfsg-2build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 13:33:04 +0000

phcpack (2.4.90+dfsg-2build1) plucky; urgency=medium

  * No-change rebuild with gnat-14

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 11 Mar 2025 13:47:50 +0000

phcpack (2.4.90+dfsg-2) unstable; urgency=medium

  * debian/control
    - Add python3-setuptools to Build-Depends-Arch (Closes: #1080698).
    - Bump Standards-Version to 4.7.2.
  * debian/copyright
    - Update my copyright years

 -- Doug Torrance <dtorrance@debian.org>  Sat, 08 Mar 2025 07:52:24 -0500

phcpack (2.4.90+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/hardening.patch
    - Refresh for new upstream release.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 21 Mar 2024 06:05:57 -0400

phcpack (2.4.89+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/clean
    - Update name of shared library to clean.
  * debian/control
    - Remove jdupes from Build-Depends.
    - Remove Testsuite field; autodep8 test wasn't doing anything.
  * debian/copyright
    - Update my copyright years.
  * debian/patches/find-shared-library.patch
    - New patch; find shared library since pybuild renames it.
  * debian/patches/hardening.patch
    - Update patch for new Python build.
  * debian/patches/no-phcpy-chdir.patch
    - New patch; don't change to system site directory when loading phcpy.
      This was preventing us from building the docs.
  * debian/patches/use-imgmath.patch
    - Update path to Sphinx config file.
  * debian/rules
    - Update build of Python module for new version.
    - Use gprclean during "dh clean".
    - Stop using jdupes; no longer necessary.
  * debian/python3-phcpy.docs
    - Update location of Python module docs
  * debian/python3-phcpy.examples
    - Update location of Python module examples.
  * debian/tests/control
    - Replace phcpy test; now a Test-Command running phcpy.version.main().
  * debian/tests/phcpy-test.py
    - Remove autopkgtest file.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 24 Feb 2024 22:56:17 -0500

phcpack (2.4.88+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 27 Dec 2023 11:14:59 -0500

phcpack (2.4.87+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright
    - Update my copyright years.
  * debian/patches
    - Refresh for new upstream release.
  * debian/rules
    - Specify UNIX Makefile (upstream now defaults to using the Windows
      one).
    - Drop -o option to gprbuild; we were using it to set the binary name
      to "phc" instead of "phctop", but "phc" is now the default.
    - Backup "phc" binary before calling gprclean before Python build;
      otherwise it will be deleted.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 16 Dec 2023 14:32:58 -0500

phcpack (2.4.86+dfsg-5) unstable; urgency=medium

  * debian/watch
    - Switch from GitHub releases to tags page for uscan download.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 20 Jun 2023 12:00:27 -0400

## phcpack 2.4.90+dfsg

=== debian/changelog ===
phcpack (2.4.90+dfsg-5) unstable; urgency=medium

  * debian/rules
    - Don't run dh_octave_check in architecture-dependent only builds.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 05 Oct 2025 08:54:54 -0400

phcpack (2.4.90+dfsg-4) unstable; urgency=medium

  * debian/rules
    - Move installation of Octave package before dh_auto_install since
      dh_octave_check is now run immediately afterward.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 05 Oct 2025 07:03:00 -0400

phcpack (2.4.90+dfsg-3) unstable; urgency=medium

  * debian/control
    - Move dh-sequence-octave from Build-Depends-Indep to Build-Depends to
      avoid "add_command_options is not supported" error.
    - Drop versioned dependency on dh-octave.  It was redundant since
      dh-sequence-octave has been provided by dh-octave since version 1.2.0.
  * debian/copyright
    - Refer to URL instead of old physical address for Free Software
      Foundation in GPL-2 text.
  * debian/patches/is-zero.patch
    - New patch; rename iszero -> is_zero to avoid conflicting with new C23
      macro (Closes: #1114643).

 -- Doug Torrance <dtorrance@debian.org>  Tue, 16 Sep 2025 15:36:59 -0400

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Build-Depends: debhelper-compat (= 13),
+               dh-sequence-octave,
                dh-sequence-sphinxdoc <!nodoc>,
                dvipng <!nodoc>,
                python3-sphinx ,
@@ -13,16 +14,14 @@
                     dh-ada-library (>= 8.2),
                     gnat (>= 11~),
                     gprbuild,
-                    jdupes <!nopython !nodoc>,
                     python3-all-dev <!nopython>,
+                    python3-setuptools <!nopython>,
                     python3-tk <!nopython>
-Build-Depends-Indep: dh-octave (>= 1.2.0~), dh-sequence-octave
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://homepages.math.uic.edu/~jan/PHCpack/phcpack.html
 Vcs-Browser: https://salsa.debian.org/math-team/phcpack
 Vcs-Git: https://salsa.debian.org/math-team/phcpack.git
 Rules-Requires-Root: no
-Testsuite: autopkgtest-pkg-pybuild
 
 Package: phcpack
 Architecture: any

## phcpack 2.4.91+dfsg

=== src/Python/PHCpy3/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest coverage gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/phcpy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/phcpy.qhc"

applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/phcpy"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/phcpy"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
phcpack (2.4.91+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/hardening.patch
    - Refresh for new upstream release.
  * debian/patches/is-zero.patch
    - Remove patch; applied upstream.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 15 Oct 2025 22:18:15 -0400

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 ifneq (,$(call command, pybuild))
 DH_OPTIONS += --buildsystem=pybuild
-PYTHON3 := $(shell pybuild --system distutils --print {interpreter.include_dir})
+PYBUILD_BUILD_DIRS := $(shell pybuild --system distutils --print {build_dir})
 endif
 
 %:
@@ -23,29 +23,32 @@
 # This line has no effect during architecture-independent builds:
 include $(wildcard /usr/share/ada/packaging.mk)
 
-export PYBUILD_DIR = src/Python/PHCpy3
+export PYBUILD_DIR = src/Python/PHCpy
 
 override_dh_auto_build-arch:
 	@echo "+------------------+"
 	@echo "| building PHCpack |"
 	@echo "+------------------+"
-	gprbuild $(GPRBUILDFLAGS) src/Ada/Main/main.gpr -o phc
+	gprbuild $(GPRBUILDFLAGS) src/Ada/Main/main.gpr
 	$(MAKE) -C src/doc man
 ifeq (,$(filter nopython, $(DEB_BUILD_PROFILES)))
 	@echo "+----------------+"
 	@echo "| building PHCpy |"
 	@echo "+----------------+"
+	mv src/bin/phc src/bin/phc.bak
 	cd src/Ada/Main && gprclean main.gpr # so we can recompile with -fPIC
-	$(MAKE) -C src/Objects phcpy2c3.so \
-		PYTHON3=$(PYTHON3)         \
-		GNATFLAGS="$(ADAFLAGS)"
+	mv src/bin/phc.bak src/bin/phc
+	gprbuild $(GPRBUILDFLAGS) src/Ada/Main/phclib.gpr
 	pybuild --build
+	cp src/lib/libPHCpack.so $(PYBUILD_DIR) # for building docs
+	for dir in $(PYBUILD_BUILD_DIRS);        \
+		do cp src/lib/libPHCpack.so $$dir; \
+	done
 ifeq (,$(filter nodoc, $(DEB_BUILD_PROFILES)))
 	@echo "+---------------------+"
 	@echo "| building PHCpy docs |"
 	@echo "+---------------------+"
-	$(MAKE) -C src/Python/PHCpy3/doc html
-	jdupes -l src/Python/PHCpy3/doc/build/html/_images/math
+	$(MAKE) -C src/Python/PHCpy/doc html
 endif
 endif
 
@@ -64,7 +67,7 @@
 
 execute_before_dh_octave_version: DESCRIPTION
 
-execute_after_dh_auto_install-indep: DESCRIPTION
+execute_before_dh_auto_install-indep: DESCRIPTION
 	@echo "+-----------------+"
 	@echo "| building PHClab |"
 	@echo "+-----------------+"
@@ -75,6 +78,8 @@
 	cp --update --reflink=auto src/Octave/*.m debian/PKG_ADD inst
 
 	dh_auto_install --buildsystem=octave
+
+override_dh_octave_check-arch:
 
 include /usr/share/dpkg/pkg-info.mk
 DESCRIPTION: debian/DESCRIPTION.in
@@ -93,7 +98,8 @@
 	dh_clean -Xbak
 
 execute_after_dh_auto_clean:
-	$(MAKE) -C src/Objects clean
-	$(MAKE) -C src/Python/PHCpy3/doc clean
+	gprclean src/Ada/Main/main.gpr || true
+	gprclean src/Ada/Main/phclib.gpr || true
+	$(MAKE) -C src/Python/PHCpy/doc clean
 	$(MAKE) -C src/doc clean
 	dh_auto_clean --buildsystem=octave || true

=== debian/watch ===
version=4
opts=dversionmangle=s/@DEB_EXT@//,repacksuffix=+dfsg \
https://github.com/janverschelde/PHCpack/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
